	TITLE	SHLINT

	LOCALS	@@

; Double byte record

b0		EQU	(BYTE PTR 0)
b1		EQU	(BYTE PTR 1)

; Double word record

w0		EQU	(WORD PTR 0)
w2		EQU	(WORD PTR 2)

; Version number

VersionNum	EQU	0053H

; Data segment

_DATA		SEGMENT WORD PUBLIC 'DATA'

; Externals

	EXTRN	ShellBuffer:DWORD

_DATA		ENDS

; Data group

DGROUP		GROUP	_DATA

; Code segment

SHLINT_TEXT	SEGMENT	BYTE PUBLIC 'CODE'

	ASSUME	CS:SHLINT_TEXT,DS:DGROUP

	PUBLIC	InitShell
	PUBLIC	DoneShell

; CS-based variables

OldInt21	DD	0	;Saved INT 21H vector

; Install INT 21H handler for DOS shell

InitShell:

	PUSH	DS
	XOR	AX,AX
	MOV	DS,AX
	MOV	DI,OFFSET OldInt21
	PUSH	CS
	POP	ES
	CLD
	CLI
	MOV	SI,21H*4
	MOVSW
	MOVSW
	MOV	WORD PTR DS:[21H*4+0],OFFSET ShellInt21
	MOV	WORD PTR DS:[21H*4+2],CS
	STI
	POP	DS
	RETF

; Remove INT 21H handler for DOS shell

DoneShell:

	PUSH	DS
	MOV	SI,OFFSET OldInt21
	PUSH	CS
	POP	DS
	XOR	AX,AX
	MOV	ES,AX
	CLD
	CLI
	MOV	DI,21H*4
	MOVSW
	MOVSW
	STI
	POP	DS
	RETF

; INT 21H handler in DOS shell for showing the presence of the Commander

ShellInt21:

	CMP	AH,2BH
	JNE	@@1
	CMP	CX,'SC'
	JNE	@@1
	CMP	DX,'OM'
	JNE	@@1
	PUSH	DS
	MOV	BX,SEG DGROUP
	MOV	DS,BX
	MOV	BX,ShellBuffer.w0
	MOV	ES,ShellBuffer.w2
	MOV	AL,0
	MOV	CL,0
	MOV	DX,VersionNum
	POP	DS
	STI
	CLC
	RETF	2
@@1:	JMP	OldInt21

SHLINT_TEXT	ENDS

	END
